﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Steema.TeeChart.Styles;
using System.IO;
using System.Drawing;
using System.Collections;
using System.Xml.Linq;
using System.Xml;
using System.Data;
using System.Threading;

namespace TeaChartDemo
{
    public partial class _Default : System.Web.UI.Page
    {
        private DataSet _tradingPrice;
     
        string dayStart, dayEnd;
        string currency = "$";
        int res = 48;
        bool intNameBeg;

        protected void Page_Load(object sender, EventArgs e)
        {
            intNameBeg = true;
            //
            dayStart = "04:30";
            dayEnd = "04:00";

            if (!Page.IsPostBack)
            {                
                LoadRegions();
            }

        }

        private void LoadChart()
        {
            
            
        }

        private void LoadRegions()
        {
            _tradingPrice = new DataSet();
            _tradingPrice.ReadXml(MapPath("prices.xml"));

            ddlRegion.DataSource = _tradingPrice.Tables[0].DefaultView.ToTable(true, "RegionID");
            ddlRegion.DataValueField = "RegionID";
            ddlRegion.DataTextField = "RegionID";
            ddlRegion.DataBind();
            
                   
        }

        int seriesIndex = 0;
        protected void btnDisplayChart_Click(object sender, EventArgs e)
        {
            //webChart.Chart.Axes.Bottom.Increment = Steema.TeeChart.Utils.DateTimeStep[10];

            _tradingPrice = new DataSet();
            _tradingPrice.ReadXml(MapPath("prices.xml"));

            DataTable dtPrice = _tradingPrice.Tables[0];

            Steema.TeeChart.Styles.Area areaSeries = new Steema.TeeChart.Styles.Area(webChart.Chart);
            areaSeries.Clear();
            areaSeries.Chart.Axes.Bottom.Labels.Angle = 90;
            //areaSeries.Chart.Axes.Bottom.Labels.DateTimeFormat = "hh.mm";

            webChart.Chart.Axes.Bottom.Increment = Steema.TeeChart.Utils.DateTimeStep[Convert.ToInt32(Steema.TeeChart.DateTimeSteps.ThirtyMinutes)];

            webChart.Chart.Axes.Bottom.Labels.DateTimeFormat = "HH.mm";
            webChart.Chart.Series[0].XValues.DateTime = true; 
            
            areaSeries.Chart.Legend.Visible = false;

            Candle priceSeries = new Candle(webChart.Chart);

            //Getprices for coverage for one region
            TimeSpan span = new TimeSpan(Convert.ToInt16(txtCoverage.Text), 0, 0,0);
            string startDate = ddcEndDate.Value.Subtract(span).ToString("yyyy-MM-dd")
                + " " + dayStart;
            string endDate = ddcEndDate.Value.ToString("yyyy-MM-dd") + " " + dayEnd;

            //Get data                        

            dtPrice.DefaultView.RowFilter = "RegionID = '" + ddlRegion.SelectedValue + "' " +
                                            "AND SETTLEMENTDATE >= '" + Convert.ToDateTime(startDate) + "' " +
                                            "AND SETTLEMENTDATE <= '" + Convert.ToDateTime(endDate) + "'";
                                                        

            string interval;
            string interval1;
            ArrayList prices;
            int n;

            //Length of interval in minutes
            TimeSpan span1 = new TimeSpan(0, Convert.ToInt16(24 * 60 / res), 0);

            interval = dayStart;

            for (n = 1; n <= res;n++ )
            {
                //Find all rpices in coverage period for each interval1
                prices = new ArrayList();

                foreach (DataRow row in dtPrice.Rows)
                {
                    if(Convert.ToDateTime(row["SETTLEMENTDATE"]).TimeOfDay.ToString() == Convert.ToDateTime(interval).TimeOfDay.ToString())
                    {
                        prices.Add(Convert.ToDouble(row["RRP"]));
                    }
                }

                // Sort to GET POEs

                prices.Sort();

                double o, h, l, c;

                o = Convert.ToDouble(prices[Convert.ToInt32(prices.Count * 0.5)]) + 0.25;
                h = Convert.ToDouble(prices[Convert.ToInt32(prices.Count * 0.9)]);
                l = Convert.ToDouble(prices[Convert.ToInt32(prices.Count * 0.1)]);
                c = Convert.ToDouble(prices[Convert.ToInt32(prices.Count * 0.5)]) - 0.25;

                if (intNameBeg)
                {
                    if ((Convert.ToDateTime(interval).TimeOfDay >= Convert.ToDateTime("00:00").TimeOfDay) && (Convert.ToDateTime(interval).TimeOfDay < Convert.ToDateTime(dayStart).TimeOfDay))
                    {
                        interval1 = "02/15/2008 " + interval;
                    }
                    else
                    {
                        interval1 = "02/15/2008 " + interval;
                    }

                }
                else
                {
                    if ((Convert.ToDateTime(interval).TimeOfDay > Convert.ToDateTime("00:00").TimeOfDay) && (Convert.ToDateTime(interval).TimeOfDay < Convert.ToDateTime(dayStart).TimeOfDay))
                    {
                        interval1 = "02/15/2008 " + interval;
                    }
                    else
                    {
                        interval1 = "02/15/2008 " + interval;
                    }
                }                

                areaSeries.Chart.Header.Text = "Prices for " + ddlRegion.Text + Convert.ToDateTime(startDate).ToString("dd-MMM-yyyy") + " to " + Convert.ToDateTime(endDate).ToString("dd-MMM-yyyy");
                areaSeries.Chart.Header.Font.Size = 10;
                areaSeries.Chart.Axes.Bottom.Title.Text = "Interval";
                areaSeries.Chart.Axes.Left.Title.Text = currency + "/MWh";

               
                priceSeries.XValues.DateTime = true;
                priceSeries.Add(Convert.ToDateTime(interval1), o, h, l, c);
               
                webChart.Chart.Series[seriesIndex].XValues.DateTime = true;
              
                //priceSeries.Add(Convert.ToDateTime(interval1), h);
                interval = Convert.ToDateTime(interval).Add(span1).ToString("HH:mm");
                Response.Write(Convert.ToDateTime(interval1).ToString() + " - " + h.ToString() +  "<br/>");
            }
            
        }



    }
}
